Description

I was playing with Ruby tonight and thought up an interesting idea to make (({require})) a bit better, so you can load multiple files

sequentially using one method call.

Currently, (({require})) supports one argument, and throws a (({TypeError})) if you pass an array:

 irb(main):001:0> require %w(json yaml)

 TypeError: can't convert Array into String

 However, there's a way to patch Kernel that makes it respond to multiple objects passed in an (({Array})).

 module Kernel

   @@require = method :require

   def require *args

     args.flatten!

     args.collect! do |a|

       raise ArgumentError.new "arguments to `require' must be strings or symbols" unless a.is_a?(

String) || a.is_a?(Symbol)

       @@require.call a.to_s

     end

     args.length == 1 ? args.first : args

   end

 end

 The new behavior doesn't actually require the modification of any code that calls (({require})) (pretty much anything, really), and new

code can take advantage of the new functionality instantly.

 irb> require %w(json yaml)

 => [true, false]

 irb> require :pp

 => false

 irb> require 'rails'

 => true

 irb> require %w(json yaml), :pp, 'rails'

 => [true, false, false, true]

 Thanks for considering this.

Related issues:

Related to Ruby - Feature #14927: Loading multiple files at once Assigned

Related to Ruby - Feature #12858: Supporting batch-requiring of files in ruby Open

History

#1 - 10/19/2012 10:11 AM - wardrop (Tom Wardrop)

I personally don't mind your suggestion. It makes sense to me. I can't think of any potential negative side effects. On that note, I think the return value

should always be a boolean, instead of a boolean OR an array of booleans depending on the input. #require should return true if any of the listed files

were loaded, or false if none of them were. If you need to determine the loaded state of each file (the lesser common use case I'd imagine), then you

should resort to looping over multiple calls to #require.

#2 - 11/24/2012 09:08 AM - mame (Yusuke Endoh)

- Status changed from Open to Assigned
- Assignee set to matz (Yukihiro Matsumoto)

- Target version set to 2.6

#3 - 11/24/2012 12:40 PM - trans (Thomas Sawyer)

It's ugly, as it makes code harder to read. Please no.

#4 - 11/25/2012 06:19 AM - prijutme4ty (Ilya Vorontsov)

Just an alternative idea. What about using Regexp as an alternative to String?

require /.*_helper/

#5 - 12/25/2017 06:15 PM - naruse (Yui NARUSE)

- Target version deleted (2.6)

#6 - 04/03/2024 04:29 AM - hsbt (Hiroshi SHIBATA)

- Description updated

#7 - 04/03/2024 04:30 AM - hsbt (Hiroshi SHIBATA)

- Related to Feature #14927: Loading multiple files at once added

#8 - 04/03/2024 04:30 AM - hsbt (Hiroshi SHIBATA)

- Related to Feature #12858: Supporting batch-requiring of files in ruby added
